//////////////////////////////////////////////////////////////////////
// Simple consol print demo
// -- dovoto
//////////////////////////////////////////////////////////////////////

#include "../../ipc.h"
#include <NDS.h>

#include <NDS/ARM9/console.h> //basic print funcionality

#include "snddrv.h"

//plays an 8 bit mono sample at 11025Hz
/*
void playGenericSound(const void* data, u32 length)
{
	snd.count = 1;
	snd.data[0].data = data;
	snd.data[0].len = length;
	snd.data[0].rate = 11025;
	snd.data[0].pan = 64;
	snd.data[0].vol = 64;
	snd.data[0].format = 1;

	DC_FlushAll();
	IPC->soundData = &snd;
}
*/
void waitForVBlank()
{
	while(!(DISP_SR & DISP_IN_VBLANK));
	while((DISP_SR & DISP_IN_VBLANK));
}

void PSG_reset()
{
  IPC->soundCommandResult = 0;
  IPC->soundCommand = SCMD_PSG_reset;
  while( !IPC->soundCommandResult ){};
}
void PSG_writeReg (e_uint32 reg, e_uint32 val)
{
  IPC->soundCommandResult = 0;
  IPC->param1 = reg;
  IPC->param2 = val;
  IPC->soundCommand = SCMD_PSG_writeReg;
  while( !IPC->soundCommandResult ){};
}

e_uint8 PSG_readReg (e_uint32 reg)
{
  IPC->soundCommandResult = 0;
  IPC->param1 = reg;
  IPC->retValue1 = 0;
  IPC->soundCommand = SCMD_PSG_readReg;
  while( !IPC->soundCommandResult ){};
  return (e_uint8)IPC->retValue1;
}
//SCC
void SCC_reset()
{
}

void SCC_writeReg(e_uint32 adr, e_uint32 val)
{
  IPC->soundCommandResult = 0;
  IPC->param1 = adr;
  IPC->param2 = val;
  IPC->soundCommand = SCMD_SCC_writeReg;
  while( !IPC->soundCommandResult ){};
}

int main(void)
{
	int adr=0, dat=0;

	videoSetMode(0); //not using the main screen
	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE); //sub bg 0 will be used to print text
	vramSetBankC(VRAM_C_SUB_BG); 

	SUB_BG0_CR = BG_MAP_BASE(31);
	
	BG_PALETTE_SUB[255] = RGB15(31,31,31);//by default font will be rendered with color 255
	
	//consoleInit() is a lot more flexible but this gets you up and running quick
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);

	consolePrintf("\n\n\tSound Test\n");

	waitForVBlank();

	//MIX CH1 ON
	PSG_writeReg(7,0xBE);
	//VOL CH1 15
	PSG_writeReg(8,0x0F);
	// CH 1 tone O4C
	PSG_writeReg(0,0xAC);
	PSG_writeReg(1,0x01);

	dat = PSG_readReg( adr );

	while(1)
	{
		
		scanKeys();

		//move the cursor
		consolePrintSet(0,10);
		consolePrintf("Touch x = %04X\n", IPC->touchX);
		consolePrintf("Touch y = %04X\n", IPC->touchY);	
		consolePrintf( "\n" );
		consolePrintf( "addr[%d] data[%d]      \n", adr, dat );

		if(keysDown() & KEY_UP ){
			if( adr == 0 ){
				adr = 15;
			}else{
				adr--;
			}
			dat = PSG_readReg( adr );
		}
		if(keysDown() & KEY_DOWN ){
			adr = (adr+1) &0xF;
			dat = PSG_readReg( adr );
		}

		if(keysDown() & KEY_LEFT ){
			if( dat == 0 ){
				dat = 0xFF;
			}else{
				dat--;
			}
		}
		if(keysDown() & KEY_RIGHT ){
			dat = (dat+1) &0xFF;
		}
		if(keysDown() & KEY_A) PSG_writeReg( adr, dat );
		
		waitForVBlank();
//		consolePrintf("PSG_writeReg 3\n");

	}
	return 0;
}
